<?php declare(strict_types=1);

namespace GirosGiroCheckout6\Database;

use GirosGiroCheckout6\GirosGiroCheckout6;
use Shopware\Core\Framework\DataAbstractionLayer\EntityDefinition;
use Shopware\Core\Framework\DataAbstractionLayer\Field\Flag\PrimaryKey;
use Shopware\Core\Framework\DataAbstractionLayer\Field\Flag\Required;
use Shopware\Core\Framework\DataAbstractionLayer\Field\IdField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\IntField;
use Shopware\Core\Framework\DataAbstractionLayer\Field\StringField;
use Shopware\Core\Framework\DataAbstractionLayer\FieldCollection;

class gc_user_pay_giroconnect_trx_definition extends EntityDefinition
{
  public const ENTITY_NAME = GirosGiroCheckout6::TABLE_GC_TRANSACTIONS;

  public function getEntityName(): string
  {
    return self::ENTITY_NAME;
  }

  public function getEntityClass(): string
  {
    return gc_user_pay_giroconnect_trx_entity::class;
  }

  protected function defineFields(): FieldCollection
  {
    return new FieldCollection([
        (new IdField('id', 'id'))->addFlags(new PrimaryKey(), new Required()),
        new IntField('trxid', 'trxid'),
        new StringField('gcreference', 'gcreference'),
        new StringField('orderid', 'orderid'),
        new StringField('girocheckout_directdebit_mandate_reference', 'girocheckout_directdebit_mandate_reference'),
        new StringField('girocheckout_capture_reference', 'girocheckout_capture_reference'),
        new StringField('girocheckout_refund_reference', 'girocheckout_refund_reference'),
        new StringField('girocheckout_payment_name', 'girocheckout_payment_name'),
        (new IntField('status', 'status'))->addFlags(new Required()),
        new StringField('userid', 'userid'),
        new StringField('comment', 'comment'),
        new StringField('purpose', 'purpose'),
        new IntField('dispatchid', 'dispatchid'),
        new IntField('chargevat', 'chargevat'),
    ]);
  }
}