const ApiService = Shopware.Classes.ApiService;

class GsgirocheckoutPaymentConfigService extends ApiService {

    constructor(httpClient, loginService, apiEndpoint = 'gsgirocheckout') {
        super(httpClient, loginService, apiEndpoint);
    }

    validate(data) {
        const headers = this.getBasicHeaders();
        const apiRoute = `_action/${this.getApiBasePath()}/validate-keys`;

        return this.httpClient
            .post(
                apiRoute,
                JSON.stringify(data),
                {
                    headers: headers
                }
            )
            .then((response) => {
                return ApiService.handleResponse(response);
            });
    }
}

export default GsgirocheckoutPaymentConfigService;