const {Application} = Shopware;
const ApiService = Shopware.Classes.ApiService;

class GsgirocheckoutPaymentService extends ApiService {
    constructor(httpClient, loginService, apiEndpoint = 'gsgirocheckout') {
        super(httpClient, loginService, apiEndpoint);
    }

    capturePayment(requestBody) {
        const apiRoute = `_action/${this.getApiBasePath()}/capture-payment`;
        return this.httpClient.post(
            apiRoute,
            requestBody,
            {
                headers: this.getBasicHeaders()
            }
        ).then((response) => {
            console.log(response.data.status + " MSG: " + response.data.message + " " + response.data.reference);
            return ApiService.handleResponse(response);
        });
    }

    refundPayment(requestBody) {
        const apiRoute = `_action/${this.getApiBasePath()}/refund-payment`;

        return this.httpClient.post(
            apiRoute,
            requestBody,
            {
                headers: this.getBasicHeaders()
            }
        ).then((response) => {
            console.log(response.data.status + " MSG: " + response.data.message+ " " + response.data.reference);
            return ApiService.handleResponse(response);
        });
    }
}

Application.addServiceProvider('GsgirocheckoutPaymentService', (container) => {
    const initContainer = Application.getContainer('init');
    return new GsgirocheckoutPaymentService(initContainer.httpClient, container.loginService);
});

