import template from './sw-plugin-config.html.twig';
import deDE from '../../../../snippet/de_DE.json';
import enGB from '../../../../snippet/en_GB.json';

const {Component, Mixin} = Shopware;
Shopware.Locale.extend('de-DE', deDE);
Shopware.Locale.extend('en-GB', enGB);

Component.override('sw-plugin-config', {
    template,

    inject: [
        'GsgirocheckoutPaymentConfigService',
    ],

    mixins: [
        Mixin.getByName('notification')
    ],

    methods: {
        validateKey() {
            let me = this;

            //GiroPay
            const giropayMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcgiropayMerchantId"]');
            const giropayProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcgiropayProjectId"]');
            const giropayProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcgiropayProjectPassword"]');

            //DirectDebit
            const directDebitMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcdirectdebitMerchantId"]');
            const directDebitProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcdirectdebitProjectId"]');
            const directDebitProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcdirectdebitProjectPassword"]');

            //CreditCardg
            const creditCardMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gccreditcardMerchantId"]');
            const creditCardProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gccreditcardProjectId"]');
            const creditCardProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gccreditcardProjectPassword"]');

            //EPS
            const epsMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcepsMerchantId"]');
            const epsProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcepsProjectId"]');
            const epsProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcepsProjectPassword"]');

            //Ideal
            const idealMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcidealMerchantId"]');
            const idealProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcidealProjectId"]');
            const idealProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcidealProjectPassword"]');

            //Bluecode
            const bluecodeMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcbluecodeMerchantId"]');
            const bluecodeProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcbluecodeProjectId"]');
            const bluecodeProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcbluecodeProjectPassword"]');

            //Paydirekt
            const paydirektMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcpaydirektMerchantId"]');
            const paydirektProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcpaydirektProjectId"]');
            const paydirektProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcpaydirektProjectPassword"]');

            //Maestro
            const maestroMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcmaestroMerchantId"]');
            const maestroProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcmaestroProjectId"]');
            const maestroProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcmaestroProjectPassword"]');

            //Sofortuw
            const sofortuwMerchantIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcsofortuwMerchantId"]');
            const sofortuwProjectIdInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcsofortuwProjectId"]');
            const sofortuwProjectPasswordInput = document.querySelector('input[name="GirosGiroCheckout6.config.gcsofortuwProjectPassword"]');

            const giropayMerchantId = !!giropayMerchantIdInput ? giropayMerchantIdInput.value : null;
            const giropayProjectId = !!giropayProjectIdInput ? giropayProjectIdInput.value : null;
            const giropayProjectPassword = !!giropayProjectPasswordInput ? giropayProjectPasswordInput.value : null;

            const creditcardMerchantId = !!creditCardMerchantIdInput ? creditCardMerchantIdInput.value : null;
            const creditcardProjectId = !!creditCardProjectIdInput ? creditCardProjectIdInput.value : null;
            const creditcardProjectPassword = !!creditCardProjectPasswordInput ? creditCardProjectPasswordInput.value : null;

            const directdebitMerchantId = !!directDebitMerchantIdInput ? directDebitMerchantIdInput.value : null;
            const directdebitProjectId = !!directDebitProjectIdInput ? directDebitProjectIdInput.value : null;
            const directdebitProjectPassword = !!directDebitProjectPasswordInput ? directDebitProjectPasswordInput.value : null;

            const epsMerchantId = !!epsMerchantIdInput ? epsMerchantIdInput.value : null;
            const epsProjectId = !!epsProjectIdInput ? epsProjectIdInput.value : null;
            const epsProjectPassword = !!epsProjectPasswordInput ? epsProjectPasswordInput.value : null;

            const idealMerchantId = !!idealMerchantIdInput ? idealMerchantIdInput.value : null;
            const idealProjectId = !!idealProjectIdInput ? idealProjectIdInput.value : null;
            const idealProjectPassword = !!idealProjectPasswordInput ? idealProjectPasswordInput.value : null;

            const bluecodeMerchantId = !!bluecodeMerchantIdInput ? bluecodeMerchantIdInput.value : null;
            const bluecodeProjectId = !!bluecodeProjectIdInput ? bluecodeProjectIdInput.value : null;
            const bluecodeProjectPassword = !!bluecodeProjectPasswordInput ? bluecodeProjectPasswordInput.value : null;

            const paydirektMerchantId = !!paydirektMerchantIdInput ? paydirektMerchantIdInput.value : null;
            const paydirektProjectId = !!paydirektProjectIdInput ? paydirektProjectIdInput.value : null;
            const paydirektProjectPassword = !!paydirektProjectPasswordInput ? paydirektProjectPasswordInput.value : null;

            const maestroMerchantId = !!maestroMerchantIdInput ? maestroMerchantIdInput.value : null;
            const maestroProjectId = !!maestroProjectIdInput ? maestroProjectIdInput.value : null;
            const maestroProjectPassword = !!maestroProjectPasswordInput ? maestroProjectPasswordInput.value : null;

            const sofortuwMerchantId = !!sofortuwMerchantIdInput ? sofortuwMerchantIdInput.value : null;
            const sofortuwProjectId = !!sofortuwProjectIdInput ? sofortuwProjectIdInput.value : null;
            const sofortuwProjectPassword = !!sofortuwProjectPasswordInput ? sofortuwProjectPasswordInput.value : null;

            var keys = {
                "giropayMerchantId": giropayMerchantId,
                "giropayProjectId": giropayProjectId,
                "giropayProjectPassword": giropayProjectPassword,
                "creditcardMerchantId": creditcardMerchantId,
                "creditcardProjectId": creditcardProjectId,
                "creditcardProjectPassword": creditcardProjectPassword,
                "directdebitMerchantId": directdebitMerchantId,
                "directdebitProjectId": directdebitProjectId,
                "directdebitProjectPassword": directdebitProjectPassword,
                "epsMerchantId": epsMerchantId,
                "epsProjectId": epsProjectId,
                "epsProjectPassword": epsProjectPassword,
                "idealMerchantId": idealMerchantId,
                "idealProjectId": idealProjectId,
                "idealProjectPassword": idealProjectPassword,
                "bluecodeMerchantId": bluecodeMerchantId,
                "bluecodeProjectId": bluecodeProjectId,
                "bluecodeProjectPassword": bluecodeProjectPassword,
                "maestroMerchantId": maestroMerchantId,
                "maestroProjectId": maestroProjectId,
                "maestroProjectPassword": maestroProjectPassword,
                "paydirektMerchantId": paydirektMerchantId,
                "paydirektProjectId": paydirektProjectId,
                "paydirektProjectPassword": paydirektProjectPassword,
                "sofortuwMerchantId": sofortuwMerchantId,
                "sofortuwProjectId": sofortuwProjectId,
                "sofortuwProjectPassword": sofortuwProjectPassword
            };

            this.GsgirocheckoutPaymentConfigService.validate({keys})
                .then((response) => {
                    if (typeof response.results) {
                        let data = response.results;
                        let valid = true;
                        for (let k in data) {
                            if (k === "giropayTransaction") {
                                giropayMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                giropayProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                giropayProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "creditCardTransaction") {
                                creditCardMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                creditCardProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                creditCardProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "directDebitTransaction") {
                                directDebitMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                directDebitProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                directDebitProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "epsTransaction") {
                                epsMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                epsProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                epsProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "idealPayment") {
                                idealMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                idealProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                idealProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "blueCodeTransaction") {
                                bluecodeMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                bluecodeProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                bluecodeProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "maestroTransaction") {
                                maestroMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                maestroProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                maestroProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "paydirektTransaction") {
                                paydirektProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                paydirektMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                paydirektProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }
                            if (k === "sofortuwTransaction") {
                                sofortuwMerchantIdInput.parentNode.parentNode.classList.remove('has--error');
                                sofortuwProjectIdInput.parentNode.parentNode.classList.remove('has--error');
                                sofortuwProjectPasswordInput.parentNode.parentNode.classList.remove('has--error');
                            }

                            if (data[k] === "ERROR") {
                                valid = false;
                                if (k === "giropayTransaction") {
                                    giropayMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    giropayProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    giropayProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "creditCardTransaction") {
                                    creditCardMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    creditCardProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    creditCardProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "directDebitTransaction") {
                                    directDebitMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    directDebitProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    directDebitProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "epsTransaction") {
                                    epsMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    epsProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    epsProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "idealPayment") {
                                    idealMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    idealProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    idealProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "blueCodeTransaction") {
                                    bluecodeMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    bluecodeProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    bluecodeProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "maestroTransaction") {
                                    maestroMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    maestroProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    maestroProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "paydirektTransaction") {
                                    paydirektProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    paydirektMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    paydirektProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                                if (k === "sofortuwTransaction") {
                                    sofortuwMerchantIdInput.parentNode.parentNode.classList.add('has--error');
                                    sofortuwProjectIdInput.parentNode.parentNode.classList.add('has--error');
                                    sofortuwProjectPasswordInput.parentNode.parentNode.classList.add('has--error');
                                }
                            }
                        }

                        let msg = '';
                        if(valid === false){
                            let messageData = {
                                title: 'Error',
                                message: 'API-Anmeldeinformationen sind falsch'
                            };
                            me.createNotificationError(messageData);
                        }else{
                            let messageData = {
                                title: 'Erfolg',
                                message: 'API-Zugangsdaten sind korrekt'
                            };
                            me.createNotificationSuccess(messageData);
                        }
                    }
                });
            }
        }
    });
