<?php
define('__GIROCHECKOUT_SDK_DEBUG__',true);

/**
 * Sample code for GiroCheckout integration of a bluecode transaction
 *
 * @filesource
 * @package Samples
 * @version $Revision: 259 $ / $Date: 2019-05-15 12:52:03 -0400 (Wed, 15 May 2019) $
 */
require '../vendor/autoload.php';
use girosolution\GiroCheckout_SDK\GiroCheckout_SDK_Request;
use girosolution\GiroCheckout_SDK\helper\GiroCheckout_SDK_TransactionType_helper;

/**
 * Configuration of the merchants identifier, project and password
 * this information can be found in the GiroCockpit's project settings
 */
$merchantID = 0;        // Your merchant ID (Verkaufer-ID)
$projectID = 0;         // Your project ID (Projekt-ID)
$projectPassword = "";  // Your project password

/* init giropay transaction and parameters */
try {
	$request = new GiroCheckout_SDK_Request(GiroCheckout_SDK_TransactionType_helper::TRANS_TYPE_BLUECODE_TRANSACTION );
	$request->setSecret($projectPassword);
	$request->addParam('merchantId',$merchantID)
	        ->addParam('projectId',$projectID)
	        ->addParam('merchantTxId', uniqid("", TRUE))
	        ->addParam('amount',1500)
	        ->addParam('currency','EUR')
	        ->addParam('purpose','Beispieltransaktion')
	        ->addParam('urlRedirect','https://www.my-domain.de/girocheckout/redirect-creditcard')
	        ->addParam('urlNotify','https://www.my-domain.de/girocheckout/redirect-creditcard')

	        //the hash field is auto generated by the SDK
	        ->submit();
	
  //echo "<pre>";print_r($request->getResponseRaw());echo "</pre>";
  
	/* if transaction succeeded update your local system an redirect the customer */
	if($request->requestHasSucceeded()) {
    $request->getResponseParam('rc');
    $request->getResponseParam('msg');
    $request->getResponseParam('reference');
    $request->getResponseParam('redirect');

    $request->redirectCustomerToPaymentProvider();
	}
	/* if the transaction did not succeed update your local system, get the responsecode and notify the customer */
	else {
    $request->getResponseParam('rc');
    $request->getResponseParam('msg');
    $request->getResponseMessage($request->getResponseParam('rc'),'DE');
	}
}
catch (Exception $e) { echo $e->getMessage(); }