<?php

namespace girosolution\GiroCheckout_SDK;
/**
 * /**
 * Payment Modul fur girosolution.de.
 *
 * @version   2.0.0
 * @author    OCS
 * @copyright 2011-2015 GiroSolution AG
 * @link      http://www.girosolution.de
 * @link      http://www.gambio.de
 * @license   http://opensource.org/licenses/gpl-2.0.php GNU Public License
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 2 of the License
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */

/**
 * Helper class which manages texts and plugin and shop versions.
 *
 * @package GiroCheckout
 */
class GiroCheckout_Utility
{
  /*
   * contains texts in different languages
   */

  private static $aTexts = array(
      'de' => array(
          'paymentTitle' => 'Zahlung durchführen',
          'btnLabelGoToCart' => 'Warenkorb ändern',
          'btnLabelGoToPaymentSelection' => 'Zahlungsart ändern',
          'pluginDescription' => 'Die Bezahllösung für Ihren erfolgreichen Online-Shop. <br/> Informationen und Registrierung unter <a href="https://www.girosolution.de" target="_blank">https://www.girosolution.de</a>',
          'merchantid' => "Verkäufer-ID",
          'projectid' => "Projekt-ID",
          'secret' => "Projekt-Passwort",
          'info' => "Die Daten für die Einstellungen entnehmen Sie bitte dem Projekt-Profil in Ihrem GiroCockpit (www.girocockpit.de).",
          'continuetopayment' => 'Weiter zur Bezahlung',
          'paymentcompleted' => 'Bezahlung abgeschlossen',
          'gotocockpit' => 'Ihre Projekt-Daten erhalten Sie in Ihrem GiroCockpit unter www.girosolution.de/user.',
          'backtoprevious' => 'Zurück',
          'purpose' => "Verwendungszweck",
          'purpose_desc' => 'Sie können in Ihren Verwendungszweck die foldenden Platzhalter verwenden:
                                                                    <ul>
                                                                      <li style="list-style: inherit;">{CUSTOMERID}: Kundennummer</li>
                                                                      <li style="list-style: inherit;">{TRANSACTIONID}: Transaktionsnummer</li>                                                                       <li style="list-style: inherit;">{SHOPNAME}: Shop Name</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERNAME}: Kundenname</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERFIRSTNAME}: Kunde Vorname</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERLASTNAME}: Kunde Nachname</li>
                                                                    </ul>
                                                                    Beispiel: Wenn Ihr Verwendungszweck "Best. 55342, TestShop" lauten soll, dann müssen Sie folgendes angeben: "{CUSTOMERID}, {SHOPNAME}".
                                                                    Die maximale Länge beträgt 27 Zeichen.',
          'settings_missing' => 'Diese Zahlungsart muss von einem Administrator konfiguriert werden, bevor sie verwendet werden kann.',
          'paymentStatusOnSuccess' => 'Zahlstatus nach erfolgreicher Bezahlung',
          'sendEmailConfig' => 'eMail bei Zahlstatus-Änderung verschicken',
          'useExternalFormService' => "Externen Formularservice verwenden",
          'transactionType' => "Transaktionsart",
          'authorize_only' => "Nur autorisieren",
          'authorize_and_sale' => "Autorisieren und buchen",
          'reserve_amount_title' => "Reservierten Betrag automatisch buchen bei Statuswechsel auf:",
          'gc_giropay' => array(
              'title' => "giropay - Online überweisen",
              'description' => "Mit giropay zahlen Sie einfach, schnell und sicher im Online-Banking Ihrer teilnehmenden Bank oder Sparkasse. Sie werden direkt zum Online-Banking Ihrer Bank weitergeleitet, wo Sie die Überweisung durch Eingabe von PIN und TAN freigeben.",
              'short_description' => "Mit giropay einfach, schnell und sicher über Ihr Online-Banking bezahlen.",
              'bank_selection' => "Ihre Bank",
              'hint_text' => "(Suchen Sie nach Bankname, BLZ, Ort oder BIC.)"
          ),
          'gc_directdebit' => array(
              'title' => "Lastschrift",
              'description' => "Hiermit ermächtigen Sie uns, den fälligen Betrag von Ihrem Konto mittels Lastschrift einzuziehen.",
              'short_description' => "Bankeinzug über das Lastschriftverfahren.",
              'IBAN' => "IBAN",
              'bank_code' => "BLZ",
              'bank_account' => "Kontonummer",
              'account_holder' => "Kontoinhaber",
              'bank_blz' => "Kontonummer/BLZ verwenden",
              'show_bank' => "Zeige Kontonummer/ BLZ Eingabefeld",
              'missingaccountholder' => 'Kontoinhaber fehlt',
              'missingblz' => 'Kontodaten fehlen',
              'missingiban' => 'IBAN fehlt',

          ),
          'gc_creditcard' => array(
              'title' => "Kreditkarte",
              'description' => "Im nächsten Schritt werden Sie aufgefordert, Ihre Kreditkartendaten einzugeben. Wenn Ihre Kreditkarte für 3D-Secure (Verified by Visa bzw. MasterCard SecureCode) freigeschaltet ist, werden Sie während des Bezahlprozesses zur Sicherheitsabfrage Ihrer Bank weitergeleitet.",
              'short_description' => "Standard-Kreditkartenzahlung."
          ),
          'gc_ideal' => array(
              'title' => "iDEAL - Online überweisen (NL)",
              'description' => "iDEAL ist das Online Überweisungssystem der niederländischen Banken, das auf dem etablierten Onlinebanking-Verfahren der Kreditinstitute basiert. Im folgenden müssen Sie Ihre Bank auswählen und können anschließend die Zahlung in Ihrem Online-Banking durchführen.",
              'short_description' => "Bezahlung per iDEAL, dem Online-Überweisungssystem der niederländischen Banken.",
              'issuer' => "Bank",
              'missingissuer' => 'Bitte geben Sie eine Bank an.'
          ),
          'gc_eps' => array(
              'title' => "eps - Online überweisung (AT)",
              'description' => "Mit eps Online-Überweisung zahlen Sie einfach, schnell und sicher im Online-Banking Ihrer Bank. Im nächsten Schritt werden Sie direkt zum Online-Banking Ihrer Bank weitergeleitet, wo Sie die Zahlung durch Eingabe von PIN und TAN freigeben.",
              'short_description' => "Bezahlung per eps, dem Online-Überweisungssystem der österreichischen Banken.",
              'bank_selection' => "Ihre Bank",
              'hint_text' => "(Suchen Sie nach Bankname, BLZ, Ort oder BIC.)"
          ),
          'gc_paydirekt' => array(
              'title' => "Paydirekt",
              'description' => "Das Online-Bezahlverfahren Ihrer Banken und Sparkassen. Sie werden auf die Webseiten von Paydirekt weiter geleitet, wo Sie sich mit Ihren persönlichen Zugangsdaten anmelden und dann die Zahlung bestätigen. Sie benötigen vorab eine Registrierung bei Paydirekt.",
              'short_description' => "Bezahlung über Paydirekt, dem Online-Bezahlverfahren Ihrer Bank oder Sparkasse in Deutschland."
          ),
          'gc_sofortuw' => array(
              'title' => "SOFORT Überweisung",
              'description' => "Mit SOFORT Überweisung geht das online Bezahlen einfach wie nie! Sie nutzen dabei ganz bequem Ihre vertrauten Online-Banking Daten und sind so auf der sicheren Seite. Sie werden auf die SOFORT-Webseiten weiter geleitet, geben dort Ihre Bankdaten ein und lösen die Online-Überweisung aus.",
              'short_description' => "Bezahlung über SOFORT-Überweisung mit Ihren Online-Banking-Daten."
          ),
          'gc_maestro' => array(
              'title' => "Maestro",
              'description' => "Maestro ist Ihre Bankkarte für den Geldautomaten, mit der Sie jetzt auch online bezahlen können. Es ist eine Debit-Karte, so dass Sie nie mehr ausgeben können, als Sie auf Ihrem Bankkonto haben.",
              'short_description' => "Bezahlung über die Maestro-Karte (Debit)."
          ),
      ),
      'en' => array(
          'paymentTitle' => 'Payment process',
          'btnLabelGoToCart' => 'Change cart',
          'btnLabelGoToPaymentSelection' => 'Change payment method',
          'pluginDescription' => 'The payment solution for your successful e-commerce. <br/> Information and Registration at <a href="https://www.girosolution.de" target="_blank">https://www.girosolution.de</a>',
          'merchantid' => "Merchant ID",
          'projectid' => "Project ID",
          'secret' => "Project password",
          'info' => "",
          'purpose' => "Purpose",
          'purpose_desc' => 'You can define your own purpose using this placeholders:
                                                                    <ul>
                                                                      <li style="list-style: inherit;">{CUSTOMERID}: Curstomer ID</li>
                                                                      <li style="list-style: inherit;">{TRANSACTIONID}: Transaction ID</li>                                                                       <li style="list-style: inherit;">{SHOPNAME}: Shop Name</li> 
                                                                      <li style="list-style: inherit;">{SHOPNAME}: Shop name</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERNAME}: Customer full name</li>
                                                                      <li style="list-style: inherit;">{CUSTOMERFIRSTNAME}: Curstomer first name</li> 
                                                                      <li style="list-style: inherit;">{CUSTOMERLASTNAME}: Customer last name</li>
                                                                    </ul>
                                                                    For example: If your purpose is "{CUSTOMERID}, {SHOPNAME}" then the submitted purpose must be "55342, TestShop"
                                                                    The maximum length of the purpose is 27 characters.',
          'continuetopayment' => 'Continue with payment',
          'paymentcompleted' => 'Payment completed',
          'gotocockpit' => 'Your project details are available in your GiroCockpit, please go to www.girosolution.de/user.',
          'backtoprevious' => 'Back',
          'settings_missing' => 'This payment method must be configured by an administrator before it can be used.',
          'paymentStatusOnSuccess' => 'Payment state after completing the payment',
          'sendEmailConfig' => 'Send email on payment status change',
          'useExternalFormService' => "Use external form service",
          'transactionType' => "Transaction Type",
          'authorize_only' => "Authorize Only",
          'authorize_and_sale' => "Authorize and Sale",
          'reserve_amount_title' => "Book reserved amount automatically with status change to:",
          'gc_giropay' => array(
              'title' => "giropay - online bank transfer",
              'description' => "With giropay you pay simply, fast and secure by the online banking of your participating bank. You will be redirected to the online banking of your bank where you authorize the credit transfer.",
              'short_description' => "Pay in an easy, fast and secure way via your online banking.",
              'bank_selection' => "bank",
              'hint_text' => "(Search by bank name, bank code, city or bic.)"
          ),
          'gc_directdebit' => array(
              'title' => "direct debit",
              'description' => "Hereby you authorize us to charge your current account with the invoiced amount by direct debit.",
              'short_description' => "Payment via direct debit.",
              'IBAN' => "iban",
              'bank_code' => "bank code",
              'bank_account' => "bank account",
              'rbDirectdebit' => "bank account",
              'account_holder' => "account holder",
              'bank_blz' => "bank account/bank code",
              'show_bank' => "Show Bank Account/ Bank Code input field",
              'missingaccountholder' => 'account holder missing',
              'missingblz' => 'account data missing',
              'missingiban' => 'IBAN missing',
          ),
          'gc_creditcard' => array(
              'title' => "credit card",
              'description' => "On the following secure website, you are asked to enter your credit card data. If your credit card is enabled for 3D Secure (Verified by Visa or MasterCard Secure Code), additional information will be passed for a security check at your bank.",
              'short_description' => "Standard credit card payment."
          ),
          'gc_ideal' => array(
              'title' => "iDEAL - online bank transfer (NL)",
              'description' => "With iDEAL you pay simply, fast and secure by online banking of your bank. You will be redirected to the online banking of your bank where you authorize the credit transfer with PIN and TAN.",
              'short_description' => "	Payment via iDEAL, the online wire transfer system of the Dutch banks.",
              'issuer' => "issuer",
              'missingissuer' => 'Please, select an issuer bank.'
          ),
          'gc_eps' => array(
              'title' => "eps - online bank transfer (AT)",
              'description' => "With eps online transfer you pay simply, fast and secure by online banking of your bank. Your will be redirected to the online banking at your bank where you authorize the credit transfer with PIN and TAN.",
              'short_description' => "Payment via eps, the online wire transfer system of the Austrian banks.",
              'bank_selection' => "bank",
              'hint_text' => "(Search by bank name, bank code, city or bic.)"
          ),
          'gc_paydirekt' => array(
              'title' => "Paydirekt",
              'description' => "The online payment method of the German banks and Sparkassen. You will be redirected to the Paydirekt web site, where you will log into your personal account and authorize the payment. You require prior registration with Paydirekt. This payment method only works with German banking accounts.",
              'short_description' => "Payment via Paydirekt, the online payment method of your bank in Germany."
          ),
          'gc_sofortuw' => array(
              'title' => "SOFORT Überweisung",
              'description' => "Direct payment via online banking. Make payments the easy way with your own online banking details – fast and direct. You will be redirected to the web site of SOFORT, where you will enter your banking data and initiate the electronic wire transfer.",
              'short_description' => "Payment via SOFORT-Überweisung with your online banking credentials."
          ),
          'gc_maestro' => array(
              'title' => "Maestro",
              'description' => "Maestro is your ATM banking card that you can now use to pay online. It's a debit facility, so you can never spend more with your Maestro card than you have in your bank account.",
              'short_description' => "Payment via your Maestro card (debit)."
          ),
      )
  );

  /**
   * Get the plugin payments method texts.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @param int $id The text key
   * @param string $pm The payment method key
   * @return string, the text
   */
  public static function getText($id, $lang, $pm = 'default')
  {
    if (strtolower($lang) == 'de' || strtolower($lang) == 'en') {
      $strlang = strtolower($lang);
    } else {
      $strlang = 'en';
    }

    if (empty($pm) || $pm == 'default') {
      return self::$aTexts[$strlang][$id];
    } else {
      return self::$aTexts[$strlang][$pm][$id];
    }
  }

  /**
   * Get the extended logo for creditcards.
   *
   * @author GiroSolution AG
   * @package GiroCheckout
   * @copyright Copyright (c) 2015, GiroSolution AG
   * @return string
   */
  public static function getExtendedLogo($UseVisaMaster = TRUE, $UseAMEX = FALSE, $UseJCB = FALSE)
  {
    $visa_msc = $UseVisaMaster;
    $amex = $UseAMEX;
    $jcb = $UseJCB;

    if (!$visa_msc && !$amex && !$jcb)
      $visa_msc = TRUE;

    return GiroCheckout_SDK_Tools::getCreditCardLogoName($visa_msc, $amex, $jcb, false, 40);
  }

}
